/***************************************************************************
	eXynth GUI library
	(C) 2010 Anti Sullin / Artec Design <anti.sullin@artecdesign.ee>

	Based on xynth library:
    (C) 2003 - 2008 by Alper Akcan <distchx@yahoo.com>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the  *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/


#ifndef FONT_H_
#define FONT_H_

typedef struct s_font_ft_s s_font_ft_t;

#include "image.h"

#if defined(__cplusplus)
	extern "C" {
#endif

typedef struct s_font_glyph_s {
	int xMin;
	int xMax;
	int yMin;
	int yMax;
	int height;
	int lineskip;
	int size;
	s_image_t *img;
} s_font_glyph_t;

typedef struct s_font_s {
	char *name;
	char *str;
	int size;
	int ascent;
	int descent;
	int height;
	int lineskip;
	int underline_offset;
	int underline_height;
	unsigned int rgb;
	s_font_glyph_t glyph;
	s_font_ft_t *ft;
} s_font_t;

int s_font_cache_init (void);
int s_font_cache_uninit (void);
int s_font_init (s_font_t **font, const char *name);
int s_font_uninit (s_font_t *font);
int s_font_set_size (s_font_t *font, int size);
int s_font_set_str (s_font_t *font, const char *str);
int s_font_set_rgb (s_font_t *font, int r, int g, int b);
int s_font_get_glyph_pos (s_font_t *font, int *pos);
#define s_font_get_glyph(f) s_font_get_glyph_pos(f, NULL)
int s_font_get_width_pos (s_font_t *font, const char *str, int *pos);
#define s_font_get_width(f,s) s_font_get_width_pos(f,s, NULL)
int s_font_utf8_to_unicode (unsigned short *unicode, const char *utf8, int l);

#if defined(__cplusplus)
	}
#endif

#endif /* FONT_H_ */
