/***************************************************************************
	eXynth GUI library
	(C) 2010 Anti Sullin / Artec Design <anti.sullin@artecdesign.ee>

	Based on xynth library:
    (C) 2003 - 2008 by Alper Akcan <distchx@yahoo.com>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the  *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef LIST_H_
#define LIST_H_

#if defined(__cplusplus)
	extern "C" {
#endif

/** list node struct
  */
typedef struct s_list_node_s s_list_node_t;
struct s_list_node_s {
	/** next element */
	s_list_node_t *next;
	/** element */
	void *element;
};

/** list struct
  */
typedef struct s_list_s {
	/** number of elements */
	int nb_elt;
	/** list node */
	s_list_node_t *node;
} s_list_t;

int s_list_init (s_list_t **li);
int s_list_uninit (s_list_t *li);
int s_list_sinit (s_list_t *li);
int s_list_suninit (s_list_t *li);

int s_list_eol (s_list_t *li, int i);
void * s_list_get (s_list_t *li, int pos);
int s_list_remove (s_list_t *li, int pos);
int s_list_add (s_list_t *li, void *el, int pos);
void * s_list_find (s_list_t *li, void *node, int (*cmp_func) (void *, void *));
int s_list_find_pos (s_list_t *li, void *node, int (*cmp_func) (void *, void *));
int s_list_get_pos (s_list_t *li, void *node);
s_list_node_t *s_list_first(s_list_t *list);
s_list_node_t *s_list_next(s_list_node_t *node);
void *s_list_element(s_list_node_t *node);
int s_list_del_next(s_list_t *li, s_list_node_t *node);

#if defined(__cplusplus)
	}
#endif

#endif /* LIST_H_ */
