#ifndef GUIDRAWAREA_H_
#define GUIDRAWAREA_H_

#include "GuiPrimitive.h"

#define GUIDRAWAREA(f,p) getPrimitive<GuiDrawArea>(f,p)

/**
 * \brief Implements drawing area
 *
 * Implements drawing area where basic lines can be drawn. When drawing lines
 * different colors can be used by setting the pixel color state accordingly.
 */

class GuiDrawArea : public GuiPrimitive
{
public:
	GuiDrawArea(int idResource, GuiFrame* pFrame);
	virtual ~GuiDrawArea();

	void setPixel(const char* rgb, int x, int y);
	void setPixel(RGB_COLOR col, int x, int y, signed char alpha = 0);
	void lineTo(const char *rgb, int x1, int y1);
	void lineTo(RGB_COLOR col, int x1, int y1);
	void clear();

protected:
	bool initArea();

	virtual void onPaint(GuiSurface *drawSurface, s_rect_t &paintArea);

private:
	 s_image_t*  imageData;
	 int x0, y0;
};

#endif /* GUIDRAWAREA_H_ */
