#ifndef GUIEDITBOX_H_
#define GUIEDITBOX_H_

#include "GuiMultiTextBox.h"

#define GUIEDITBOX(f,p) getPrimitive<GuiEditBox>(f,p)

#define CURSOR_WIDTH	1

/**
 * \brief Edit box primitive
 * 
 * Implements basic edit box primitive. Edit box provides ability
 * to modify the text in edit box field by editing the text at cursor
 * location. Cursor position can be changed by appropriate methods.
 *
 * \author Anti Sullin
 */
class GuiEditBox : public GuiMultiTextBox
{
public:
	GuiEditBox(int idResource, GuiFrame* pFrame);
	virtual ~GuiEditBox();

	void setCursor(size_t pos);
	void setCursor(int x, int y);
	size_t getCursor();

	virtual void setSelection(SELECTION type, int x, int y);

	void insertText(const char *text);
	void delText();
	virtual void setText(const char *t);
	std::string getText();

protected:
	void onPaint(GuiSurface *drawSurface, s_rect_t &paintArea);

	void calcCursorPos();

	/** Text that the edit box holds **/
	std::string text;

	/** Cursor position within string **/
	size_t cursor;

	/** Cursor line number **/
	int cursorLine;

	/** Cursor X coordinate within the line **/
	int cursorPos;

};

#endif /*GUIEDITBOX_H_*/
