#ifndef GSM_H_
#define GSM_H_

#include <time.h>

enum MODEM_POWER_MODE { POWER_MINIMAL=0, POWER_FULL=1, POWER_NOTX=2,
		POWER_NORXTX=4, POWER_FULL_SAVE=5 };

enum MODULE_FREQ_BAND { FREQ_AUTODETECT=-1, FREQ_900X1800=0, FREQ_900X1900,
		FREQ_850X1800, FREQ_850X1900 };

enum MODEM_ANSWER { AT_TIMEOUT = -1, AT_IO_FAIL = -2, AT_PARSE_FAIL = -3, AT_SMALL_BUFFER = -4,
	AT_PARTIAL = -5, AT_OK = 0, AT_CONNECT, AT_RING, AT_NOCARIER, AT_ERROR,
	AT_NOANSWER, AT_CMS_ERROR, AT_CME_ERROR };

int modemInit(const char* portName);
int modemClose();
int modemPowerUp();
int modemPowerDown();
int modemSendCommand(const char* pCmd);
int modemReadAnswer(char *pAnswer, int answerSize, int timeOut);
int modemReadLine(char *pAnswer, int timeOut);
int modemHandShake();
int modemReadRTC(struct tm* pDate);
int modemWriteRTC(struct tm* pDate);
int modemReadADC(int idADC);
int modemSetPowerMode(int idMode);
int modemSetBand(int freqBand);

#endif /*GSM_H_*/
