/*
 * BluetoothConnection.h
 *
 *  Created on: 21.06.2011
 *      Author: ivari
 */

#ifndef BLUETOOTHCONNECTION_H_
#define BLUETOOTHCONNECTION_H_

#include "NetworkConnection.h"
#include "BluetoothModule.h"
#include "BlueGigaBluetoothModule.h"
#include "Thread.h"

struct BT_CONNECTION_SETTINGS {

	//Bluetooth paring pin code
	std::string		pin;
	std::string		lap;
	std::string		peerMAC;
};


class BluetoothConnection : public NetworkConnection {

public:
	BluetoothConnection(BT_CONNECTION_SETTINGS *pSettings);
	virtual ~BluetoothConnection();

	virtual bool isConnectionUp();
	virtual bool getNetworkInfo(GENERIC_NETWORK_INFO &netInfo);

	BluetoothModule * getBluetoothModule() { return bluetoothModule; }

protected:
	virtual bool netInitialize();
	virtual bool netShutdown();
	virtual bool netConnect();
	virtual bool netDisconnect();
	virtual bool netSuspend();
	virtual bool netResume();

private:
	BluetoothModule				*bluetoothModule;
	BT_CONNECTION_SETTINGS		cfg;

};



#endif /* BLUETOOTHCONNECTION_H_ */
