/*
 * BluetoothPort.h
 *
 *  Created on: 21.06.2011
 *      Author: ivari
 */

#ifndef BLUETOOTHPORT_H_
#define BLUETOOTHPORT_H_

#include "SerialPort.h"
#include "Thread.h"
#include "BluetoothModule.h"

#define DEFAULT_BT_TIMEOUT		5000


class BluetoothReader : protected Thread {

public:
	BluetoothReader(BluetoothModule *btModule);
	~BluetoothReader();

	Semaphore pollSem;

protected:
	virtual void run();

private:
	BluetoothModule *btModule;
};


class BluetoothPort : public SerialPort {

public:
	BluetoothPort();
	~BluetoothPort();

	ssize_t write(const char *pData, size_t len);

	BluetoothModule::AnswerType getAnswerType() { return modemAnswerType; }
	void setAnswerType(BluetoothModule::AnswerType type) { modemAnswerType = type; }

	bool initReader(BluetoothModule *btModule);
	void startRead();

private:
	BluetoothModule::AnswerType		modemAnswerType;
	BluetoothReader					*btReader;
};

#endif /* BLUETOOTHPORT_H_ */
