/*
 * Spatha.h
 *
 *  Created on: Jul 29, 2009
 *      Author: andrei
 */

#ifndef SPATHA_H_
#define SPATHA_H_

/**
 * \mainpage
 *
 * Welcome to the Triskan TS8 hardware support library \b (libspatha)
 * documentation.
 *
 * Libspatha is a C++ class library that implements a number of basic mobile
 * data terminal functions and simplifies application development.
 * The library includes simple helpers for device power management, I/O and
 * media, multithreading, connectivity and system information.
 * The library should be linked with user applications dynamically or
 * statically.
 *
 * The library is designed for embedded Linux running on Artec Triskan TS8
 * hardware.
 *
 * \author Andrei Birjukov, Anti Sullin, Jaanus Sepp
 *
 * (c) 2008-2009 Artec Design LLC
 */

#define USE_XYNTH

#define EV_NETWORK_STATUS	0x01	// char* error
#define EV_NETWORK_ERROR	0x02	// char* error
#define EV_NETWORK_SIGNAL	0x03	// int signal (0...100)
#define EV_NETWORK_STATE	0x04	// int state

#define EV_POWER_BATTERY	0x10	// int level (0...100)
#define EV_POWER_LOWBAT		0x11
#define EV_SHUTDOWN			0x1F

#define EV_TEMPERATURE		0x20	// int temp in 0.1C

#define EV_READER			0x100	// reader_data_t data
#define EV_READER_ERR		0x101	// reader_err_t err

#endif /* SPATHA_H_ */
